// OldObject.cpp : Implementation of COldObject

#include "stdafx.h"
#include "ExtObj.h"
#include "OldObj.h"

//////////////////////////////////////////////////////////////////
// COldObject

STDMETHODIMP COldObject::InterfaceSupportsErrorInfo(REFIID riid)
{ 
    static const IID* arr[] = 
    {
        &IID_IOldObject,
        &IID_INewObject
    };
    for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
    {
        if (InlineIsEqualGUID(*arr[i],riid))
            return S_OK;
    }
    return S_FALSE;
}


STDMETHODIMP COldObject::get_Name(BSTR *FullName)
{
    if (FullName == NULL)
        return E_POINTER;

    *FullName = m_strName.Copy();
    return S_OK;
}

STDMETHODIMP COldObject::put_Name(BSTR FullName)
{
    m_strName = FullName;
    return S_OK;
}

STDMETHODIMP COldObject::get_Name2(BSTR *FullName)
{
    HRESULT hrRet = S_OK;           // assume all is OK.
    CComBSTR temp;


    if (FullName == NULL)
        return E_POINTER;

    temp = m_strName;               // create a temporary copy.
    hrRet = temp.ToUpper();
    if (SUCCEEDED(hrRet))
    {
        *FullName = temp.Copy();
    }

    return hrRet;
}

STDMETHODIMP COldObject::put_Name2(BSTR FullName)
{
    m_strName = FullName;
    return S_OK;
}



