// OldObject.h : Declaration of the COldObject

#ifndef __OLDOBJECT_H_
#define __OLDOBJECT_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////
// COldObject
class ATL_NO_VTABLE COldObject : 
    public CComObjectRootEx<CComMultiThreadModel>,
    public CComCoClass<COldObject, &CLSID_OldObject>,
    public ISupportErrorInfo,
    public IDispatchImpl<IOldObject, &IID_IOldObject,
                         &LIBID_EXTENDOBJECTSLib>,
    public IDispatchImpl<INewObject, &IID_INewObject,
                         &LIBID_EXTENDOBJECTSLib>
{
public:
    COldObject()
    {
        m_strName = _T("");
    }

    DECLARE_REGISTRY_RESOURCEID(IDR_OLDOBJECT)

    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(COldObject)
        COM_INTERFACE_ENTRY(IOldObject)
        COM_INTERFACE_ENTRY(INewObject)
        COM_INTERFACE_ENTRY2(IDispatch, IOldObject)
        COM_INTERFACE_ENTRY(ISupportErrorInfo)
    END_COM_MAP()

    // ISupportsErrorInfo
    STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


    // INewObject interface properties
public:
    STDMETHOD(get_Name2)(/*[out, retval]*/ BSTR *pVal);
    STDMETHOD(put_Name2)(/*[in]*/ BSTR newVal);

    // IOldObject interface properties
public:
    STDMETHOD(get_Name)(/*[out, retval]*/ BSTR *pVal);
    STDMETHOD(put_Name)(/*[in]*/ BSTR newVal);


private:
    CComBSTR m_strName;
};

#endif //__OLDOBJECT_H_
